#!/usr/bin/perl
#--NetShopOwner-CGI-version:4.2.5.5--

;#
;# support3.cgi
;# [PC]₢킹
;# Copyright (c) 2004- Increment P Corp. All rights reserved.
;#
;# 2009/09/30 NSO4Ή
;#

use strict;
use uselib;
use defnsopath_shop;
use NsoVersionPC 1.00;
use NsoMail;
use Lib::SiteStatus;
use Design::NsoMailBody;
use DB::NsoSupportDB;

&ReadParse();
my %in    = %main::in;
my %incfn = %main::incfn;
my %inct  = %main::inct;

# CX^X`
my $objConfigSystem = Config::NsoSystem->newShop();
my $objConfigMaster = Config::NsoMaster->new();
my $NsoMisc       = NsoMisc->new();
my $NsoSupportDB    = NsoSupportDB->new();

# RtBO[ṼLbV
my %ConfigSystem = $objConfigSystem->cache_config();
my %ConfigMaster = $objConfigMaster->cache_config();

my $status_err;

FUNC:{
	my $func = $in{func} || 'main';
	my %function = (
		main       => \&main,
	);
	
	&check_request_method();
	&check_http_referer();
	&check_closing();
	
	if ($function{$func}){
		$function{$func}->();
	}else{
		&main();
	}
}
exit();

;#
;# NGXg\bh
;#
sub check_request_method {
	unless ($ENV{REQUEST_METHOD} eq 'POST'){
		my $Support1URL = $ConfigSystem{base_href}{cgishop}.$ConfigSystem{shop_script_name}{support1};
		print $NsoMisc->redirect( $NsoMisc->getChangedURL({url=>$Support1URL, key=>'AfterCart'}) );
		exit();
	}
}

;#
;# HTTP_REFERER
;# 
;#
sub check_http_referer {
	return if( !$ConfigSystem{Default}{Referer}{Check} );
	
	my $cgiroot = $NsoMisc->getChangedURL({url=>$ConfigSystem{base_href}{cgishop}, key=>'AfterCart'});
	my $Support1URL = $ConfigSystem{base_href}{cgishop}.$ConfigSystem{shop_script_name}{support1};
	
	unless ($ENV{HTTP_REFERER} =~ /$cgiroot/i){
		print $NsoMisc->redirect( $NsoMisc->getChangedURL({url=>$Support1URL, key=>'AfterCart'}) );
		exit();
	}
}

;#
;# JXEXԌ
;#
sub check_closing {
	my $SiteStatus = Lib::SiteStatus->new({ ConfigSystem=>\%ConfigSystem });
	$SiteStatus->CheckClosing({ IgnoreFlag=>1 });
}

;#
;# C
;#
sub main {
	
	# [M
	&mail_send;
	
	my %htmls = ();
	$htmls{status_err} = $status_err;
	
	# HTML^O
	my %Text = ();
	foreach my $key ( keys( %in) ) {
		$Text{$key} = $NsoMisc->html_encode($in{$key});
	}

	# HTMLŕ\ł悤
	$htmls{Inquiry} = $Text{Inquiry};
	$htmls{Inquiry} =~ s/[\n]/<BR>/ig; 

	my %replace_templ = (
		Text    => \%Text,
		htmls   => \%htmls,
	);

	print $NsoMisc->print_header();
	
	# ev[gu
	my $system_templ_dir   = $main::nsoDB_path ."/";
	my $system_templ_kind  = "templ";
	my $Data = "support3.htmp";
	my $NsoTempl = NsoTempl->new({ DataDir=>$system_templ_dir, DirKind=>$system_templ_kind, Data=>$Data });
	print $NsoTempl->replace_templ(\%replace_templ);
	exit();
}

;#
;# [M
;#
sub mail_send {
	
	# ⍇
	my @date = ();
	push(@date, 
		join("/", unpack("a4a2a2", $NsoMisc->get_date({ type=>'yyyymmdd' }))),
		join(":", unpack("a2a2a2", $NsoMisc->get_date({ type=>'hhmmss' })))
	);
	my $RegistDate = join(" ", @date);
	
	# ⍇ID
	my $SupportID = $NsoSupportDB->make_SupportID();
	
	# [f[^
	my @mailhead = (
		{ label=>q(⍇ID), value=>$SupportID },
		{ label=>q(t), value=>$RegistDate },
	);
	my @mailbody1 = (
		{ label=>q(O),, value=>$in{Name} },
		{ label=>q(e-mail),, value=>$in{Mail} },
		{ label=>q(), value=>$in{Subject} },
		{ label=>q(⍇e), value=>q() }
	);
	# ͍̑ڂ̃f[^
	my @mailbody2 = ();
	my @nums = qw(1 2 3 4);
	foreach my $num (@nums){
		my $question = "question$num";
		my $question_title = "question$num"."_title";
		# ږ̂Ƃ́Af[^𐶐ȂB
		if ($in{$question_title} ne ""){
			push(@mailbody2, {label=>$in{$question_title}, value=>$in{$question} });
		}
	}
	
	my $SendmailPath = $ConfigSystem{sendmail}{path};
	my @err_list = ();
	
	# PC[M
	MAIL1:{
		my $NsoMailBody = Design::NsoMailBody->new();
		my @Head  = $NsoMailBody->PutInOrder({ bodylist=>\@mailhead });
		my @Body1 = $NsoMailBody->PutInOrder({ bodylist=>\@mailbody1 });
		my @Body2 = $NsoMailBody->PutInOrder({ bodylist=>\@mailbody2 });
		my $hr = q() x 36;
		my $BodyAll = join("\n", $hr, @Head, $hr, @Body1, "", $in{Inquiry}, @Body2, $hr);
		
		# Subject̏킹B
		my $Subject = "[No." . $SupportID . "] $ConfigMaster{EachMaster}{Mail}{Support}{Subject}";
		
		# ₢킹[PCToɂ̂ݑM
		my %args = (
			fromname => $in{Name},
			from     => $in{Mail},
			to       => $ConfigMaster{EachMaster}{Mail}{pc}{To},
			cc       => '',
			bcc      => '',
			subject  => $Subject,
			body     => $BodyAll,
		);
		
		my $NsoMail = NsoMail->new({ path=>$SendmailPath });
		unless ($NsoMail->send_mail(\%args)){
			my $err_str = "炩̌ɂ⍇[̑MɎs܂";
			push(@err_list, $err_str);
		}
	};
	
	$status_err = join("<br>", @err_list) if (@err_list > 0);
}












